Data source binding and custom menu items in EJ2 JavaScript Menu

21 Aug 202624 minutes to read

Data binding

The Menu supports data source bindings such as array of JavaScript objects that can be structured as either hierarchical or self-referential data.

Hierarchical data

The Menu can be populated with hierarchical data source by assigning it to the items property, and the fields with corresponding keys can be mapped to the fields property.

JSON data

The Menu can generate its menu items through an array of complex data source by mapping fields from the fields property.

ej.base.enableRipple(true);

//Menu datasource
var dataSource = [
    {
        continent: 'Asia',
        countries: [
            {
                country: 'China',
                languages: [
                    { language: 'Chinese' },
                    { language: 'Cantonese' }
                ]
            },
            {
                country: 'India',
                languages: [
                    { language: 'English' },
                    { language: 'Hindi' },
                    { language: 'Tamil' }
                ]
            },
            {
                country: 'Japan',
                languages: [
                    { language: 'Japanese' }
                ]
            }
        ]
    },
    {
        continent: 'Africa',
        countries: [
            {
                country: 'Nigeria',
                languages: [
                    { language: 'English' },
                    { language: 'Hausa' }
                ]
            },
            {
                country: 'Egypt',
                languages: [
                    { language: 'Arabic' }
                ]
            },
            {
                country: 'South Africa',
                languages: [
                    { language: 'Tswana' },
                    { language: 'Swati' }
                ]
            }
        ]
    },
    {
        continent: 'North America',
        countries: [
            {
                country: 'Canada',
                languages: [
                    { language: 'French' }
                ]
            },
            {
                country: 'Mexico',
                languages: [
                    { language: 'Spanish' }
                ]
            },
            {
                country: 'USA',
                languages: [
                    { language: 'English' }
                ]
            }
        ]
    },
    {
        continent: 'South America',
        countries: [
            {
                country: 'Brazil',
                languages: [
                    { language: 'Portuguese' }
                ]
            },
            {
                country: 'Colombia',
                languages: [
                    { language: 'Spanish' }
                ]
            },
            {
                country: 'Argentina',
                languages: [
                    { language: 'Spanish' }
                ]
            }
        ]
    },
    {
        continent: 'Oceania',
        countries: [
            {
                country: 'Australia'
            },
            {
                country: 'New Zealand'
            },
            {
                country: 'Samoa'
            },
        ]
    }
];

//Menu fields definition
var menuFields = {
    text: ['continent', 'country', 'language'],
    children: ['countries', 'languages']
};

// Initialize Menu component.
var menuObj = new ej.navigations.Menu({ items: dataSource, fields: menuFields }, '#menu');
<!DOCTYPE html><html lang="en"><head>
    <title>Essential JS 2</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no">
    <meta name="description" content="Essential JS 2">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-base/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-popups/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-navigations/styles/bootstrap5.3.css" rel="stylesheet">

    <!--style reference from app-->
    <link href="styles.css" rel="stylesheet">

    <!--system js reference and configuration-->
    
    
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div class="control-section">
            <ul id="menu"></ul>
        </div>
    </div>



<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Data Service

In application level, remote data binding can be achieved using DataManager. To create Menu, assign items property with resultant data from callback function.

The following example displays five employees’ FirstName from Employees table and ShipName details from Orders table of the Northwind Data Service.

ej.base.enableRipple(true);

var SERVICE_URI = 'https://services.odata.org/V4/Northwind/Northwind.svc/';

var menuFields = {
    text: ['FirstName','ShipName'],
    children: ['Orders']
};

new ej.data.DataManager({ url: SERVICE_URI, adaptor: new ej.data.ODataV4Adaptor(), crossDomain: true })
.executeQuery(
new ej.data.Query().from('Employees').take(5).hierarchy(
    new ej.data.Query()
    .foreignKey('EmployeeID')
    .from('Orders').take(13),
    function() {
        return [1,2,3,4,5]
    }
))
.then(function (e) {
    new ej.navigations.Menu({ items: e.result, fields: menuFields  }, '#menu');
});
<!DOCTYPE html><html lang="en"><head>
    <title>Essential JS 2</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no">
    <meta name="description" content="Essential JS 2">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-base/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-popups/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-navigations/styles/bootstrap5.3.css" rel="stylesheet">

    <!--style reference from app-->
    <link href="styles.css" rel="stylesheet">

    <!--system js reference and configuration-->
    
    
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div class="control-section">
            <ul id="menu"></ul>
        </div>
    </div>



<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Self-referential data

Menu can be populated from self-referential data structure that contains array of JSON objects with parentId mapping.

In the following example, the id, pId, and text columns from self-referential data have been mapped to the itemId, parentId, and text fields, respectively.

ej.base.enableRipple(true);

//Menu datasource
var data = [
    { id: 'parent1', text: 'Events' },
    { id: 'parent2', text: 'Movies' },
    { id: 'parent3', text: 'Directory' },
    { id: 'parent4', text: 'Queries', pId: null },
    { id: 'parent5', text: 'Services', pId: null },

    { id: 'parent6', text: 'Conferences', pId: 'parent1' },
    { id: 'parent7', text: 'Music', pId: 'parent1' },
    { id: 'parent8', text: 'Workshops', pId: 'parent1' },

    { id: 'parent9', text: 'Now Showing', pId: 'parent2' },
    { id: 'parent10', text: 'Coming Soon', pId: 'parent2' },

    { id: 'parent10', text: 'Media Gallery', pId: 'parent3' },
    { id: 'parent11', text: 'Newsletters', pId: 'parent3' },

    { id: 'parent12', text: 'Our Policy', pId: 'parent4' },
    { id: 'parent13', text: 'Site Map', pId: 'parent4' },
    { id: 'parent14', text: 'Pop', pId: 'parent7' },
    { id: 'parent15', text: 'Folk', pId: 'parent7' },
    { id: 'parent16', text: 'Classical', pId: 'parent7' }
];

//Menu fields definition
var menuFields = {
    itemId:'id',
    text: 'text',
    parentId: 'pId'
};

// Initialize Menu component.
var menuObj = new ej.navigations.Menu({ items: data, fields: menuFields }, '#menu');
<!DOCTYPE html><html lang="en"><head>
    <title>Essential JS 2</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no">
    <meta name="description" content="Essential JS 2">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-base/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-popups/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-navigations/styles/bootstrap5.3.css" rel="stylesheet">

    <!--style reference from app-->
    <link href="styles.css" rel="stylesheet">

    <!--system js reference and configuration-->
    
    
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div class="control-section">
            <ul id="menu"></ul>
        </div>
    </div>



<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

HTML element

The Menu can be initialized using <UL> element that contains a collection of <LI> elements. A <LI> item acts as a menu item of the Menu, and the sub <UL> element inside the <LI> element acts as a sub menu item of its preceding menu item.

ej.base.enableRipple(true);

// Initialize Menu component.
var menuObj = new ej.navigations.Menu(null, '#menu');
<!DOCTYPE html><html lang="en"><head>
    <title>Essential JS 2</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no">
    <meta name="description" content="Essential JS 2">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-base/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-popups/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-navigations/styles/bootstrap5.3.css" rel="stylesheet">

    <!--style reference from app-->
    <link href="styles.css" rel="stylesheet">

    <!--system js reference and configuration-->
    
    
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <ul id="menu">
            <li id="leafy_salad"><a>Leafy</a>
                <ul>
                    <li>Broccoli</li>
                    <li>Cabbage</li>
                    <li>Spinach</li>
                </ul>
            </li>
            <li id="beans"><a>Beans</a>
                <ul>
                    <li>Chickpea</li>
                    <li>Green bean</li>
                    <li>Horse gram</li>
                </ul>
            </li>
            <li id="bulb_stem"><a>Bulb and Stem</a>
                <ul>
                    <li>Pearl onion</li>
                    <li>Garlic</li>
                    <li>Shallot</li>
                    <li>Lotus root</li>
                </ul>
            </li>
            <li id="root_tuberous"><a>Root</a>
                <ul>
                    <li>Beetroot</li>
                    <li>Carrot</li>
                    <li>Ginger</li>
                    <li>Turmeric</li>
                </ul>
            </li>
            <li id="pod"><a>Podded</a>
                <ul>
                    <li>American groundnut</li>
                    <li>Drumstick</li>
                    <li>Horse gram</li>
                    <li>Peanut</li>
                </ul>
            </li>
        </ul>
    </div>



<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Custom menu items

The Menu can be customized using Essential® JS2 Template engine to render the elements.

To customize menu items in your application, set your customized template string to the template property. In the following example, the menu has been rendered with customized menu items.

ej.base.enableRipple(false);

//Menu data definition
var data = [
    {
        category: 'Products',
        options: [
            { value: 'JavaScript', url: 'javascript' },
            { value: 'Angular', url: 'angular' },
            { value: 'ASP.NET Core', url: 'core' },
            { value: 'ASP.NET MVC', url: 'mvc' }
        ]
    },
    {
        category: 'Services',
        options: [
            {
                support: [
                    { value: 'Application Development', count: '1200+' },
                    { value: 'Maintenance & Support', count: '3700+' },
                    { value: 'Quality Assurance' },
                    { value: 'Cloud Integration', count: '900+' }
                ]
            }
        ]
    },
    {
        category: 'About Us',
        options: [
            {
                about: {
                    value: "We are on a mission to provide world-class best software solutions for web, mobile and desktop platforms. Around 900+ applications are desgined and delivered to our customers to make digital & strengthen their businesses."
                }
            }
        ]
    },
    { category: 'Careers' },
    { category: 'Sign In' }
];

//Menu fields definition 
var menuFields  = {
    text: ['category', 'value'],
    children: ['options']
};

//Menu initialization
var menuObj = new ej.navigations.Menu({
    items: data,
    fields: menuFields,
    template: '#menuTemplate'
}, '#menu');
<!DOCTYPE html><html lang="en"><head>
    <title>Essential JS 2</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no">
    <meta name="description" content="Essential JS 2">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-base/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-popups/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-navigations/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-buttons/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-inputs/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-dropdowns/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-cards/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-notifications/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-layouts/styles/bootstrap5.3.css" rel="stylesheet">

    <!--style reference from app-->
    <link href="styles.css" rel="stylesheet">

    <!--system js reference and configuration-->
    
    
<script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
</head>
<body>
    
    <div id="container">
        <div class="menu-section">
            <ul id="menu"></ul>
        </div>
    </div>
        <script id="menuTemplate" type="text/x-template">
        ${if(category)}
            ${category}
        ${else if (value && url)}
            <div class="e-avatar e-avatar-small image" style="background-image: url(${url}.png);">${value}</div>
        ${else if (support)}
            <ul>
                ${for(val of support)}
                <li>
                    ${val.value}
                    ${if(val.count)}
                        <span class='e-badge e-badge-success'>${val.count}</span>
                    ${/if}
                </li>
                ${/for}
            </ul>
        ${else}        
        <div tabindex="0" class="e-card">
            <div class="e-card-header">
                <div class="e-card-header-caption">
                    <div class="e-card-header-title">About Us</div>
                </div>
            </div>
            <div class="e-card-content">
                ${about.value}
            </div>
            <div class="e-card-actions">
                <button class="e-btn e-outline">
                    Read More
                </button>
            </div>
        </div>
        ${/if}
    </script>



<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

To prevent sub menu closing, set args.cancel to true in beforeClose event.

See Also

Data Source Binding and Custom Menu Items in Angular Menu Bar

26 Sep 202619 minutes to read

This section covers binding the Angular Menu Bar component to hierarchical or self-referential data sources and customizing menu items using templates.

Data binding

The Angular Menu Bar component supports data source bindings such as arrays of JavaScript objects structured as either hierarchical or self-referential data.

Hierarchical data

The Angular Menu Bar can be populated with a hierarchical data source by assigning it to the items property, and mapping fields with corresponding keys to the fields property, which includes sub options like itemId, text, and children to align data source properties with the Menu’s structure.

JSON data

The Angular Menu Bar can generate its menu items from an array of complex data sources by mapping fields from the fields property.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { MenuModule } from '@syncfusion/ej2-angular-navigations'



import { Component } from '@angular/core';
import { enableRipple } from '@syncfusion/ej2-base';
import { FieldSettingsModel } from '@syncfusion/ej2-angular-navigations';

// Import an array of JSON data from datasource.ts
import { dataSource } from './datasource';

enableRipple(true);

@Component({
imports: [ MenuModule],


standalone: true,
    selector: 'app-root',
    template: `<div class="e-section-control">
    <ejs-menu [items]="data" [fields]='menuFields'></ejs-menu></div>`
})

export class AppComponent {
    public menuFields: FieldSettingsModel = {
        text: ['continent', 'country', 'language'],
        children: ['countries', 'languages']
    };

    public data: { [key: string]: Object }[] = dataSource;
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Data Service

In application level, remote data binding can be achieved using DataManager.
To create Angular Menu Bar, assign items property with resultant data from callback function.

The following example displays five employees’ FirstName from the Employees table and ShipName details from the Orders table of the Northwind Data Service.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { MenuModule } from '@syncfusion/ej2-angular-navigations'



import { Component, OnInit } from '@angular/core';
import { enableRipple } from '@syncfusion/ej2-base';
import { DataManager, Query, ODataV4Adaptor, ReturnOption } from '@syncfusion/ej2-data';
import { FieldSettingsModel } from '@syncfusion/ej2-angular-navigations';

enableRipple(true);

@Component({
imports: [ MenuModule],


standalone: true,
    selector: 'app-root',
    template: `<div class="e-section-control">
    <ejs-menu *ngIf='menuItems' [items]='menuItems' [fields]='menuFields'></ejs-menu></div>`
})

export class AppComponent implements OnInit {

    private SERVICE_URI: string = 'https://services.odata.org/V4/Northwind/Northwind.svc/';

    // Menu fields definition.
    public menuFields: FieldSettingsModel = {
        text: ['FirstName', 'ShipName'],
        children: ['Orders']
    };

    public menuItems?: { [key: string]: Object }[];

    public ngOnInit(): void {
        // Getting remote data using DataManager.
        new DataManager({ url: this.SERVICE_URI, adaptor: new ODataV4Adaptor(), crossDomain: true })
            .executeQuery(
                new Query().from('Employees').take(5).hierarchy(
                    new Query()
                        .foreignKey('EmployeeID')
                        .from('Orders').take(13),
                    function () {
                        return [1, 2, 3, 4, 5]
                    }
                ))
            .then((e: ReturnOption) => {
                //Assign result data to menu items
                this.menuItems = e.result as { [key: string]: Object }[];
                const loaderElement = document.getElementById('loader') as HTMLElement;
                if (loaderElement) {
                    loaderElement.style.display = "none";
                }
            });
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Self-referential data

The Angular Menu Bar can be populated from a self-referential data structure, consisting of an array of JSON objects with parentId mapping.

Directly assign self-referential data to the items property, and map all field members with corresponding keys to the fields property, where itemId uniquely identifies each menu item and parentId links child items to their parent.

To render root-level nodes, specify parentId as null or omit the parentId for root-level nodes in the data source.

In the following example, the id, pId, and text columns from self-referential data have been mapped to the itemId, parentId, and text fields, respectively.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { MenuModule } from '@syncfusion/ej2-angular-navigations'



import { Component } from '@angular/core';
import { enableRipple } from '@syncfusion/ej2-base';
import { FieldSettingsModel } from '@syncfusion/ej2-angular-navigations';

enableRipple(true);

@Component({
imports: [ MenuModule],


standalone: true,
    selector: 'app-root',
    template: `<div class="e-section-control">
            <ejs-menu [items]='data' [fields]='menuFields'></ejs-menu>
            </div>`
})

export class AppComponent {
    //Menu datasource
    public data: { [key: string]: Object }[] = [
        { id: 'parent1', text: 'Events' },
        { id: 'parent2', text: 'Movies' },
        { id: 'parent3', text: 'Directory' },
        { id: 'parent4', text: 'Queries', pId: null as any },
        { id: 'parent5', text: 'Services', pId: null as any },

        { id: 'parent6', text: 'Conferences', pId: 'parent1' },
        { id: 'parent7', text: 'Music', pId: 'parent1' },
        { id: 'parent8', text: 'Workshops', pId: 'parent1' },

        { id: 'parent9', text: 'Now Showing', pId: 'parent2' },
        { id: 'parent10', text: 'Coming Soon', pId: 'parent2' },

        { id: 'parent10', text: 'Media Gallery', pId: 'parent3' },
        { id: 'parent11', text: 'Newsletters', pId: 'parent3' },

        { id: 'parent12', text: 'Our Policy', pId: 'parent4' },
        { id: 'parent13', text: 'Site Map', pId: 'parent4' },
        { id: 'parent14', text: 'Pop', pId: 'parent7' },
        { id: 'parent15', text: 'Folk', pId: 'parent7' },
        { id: 'parent16', text: 'Classical', pId: 'parent7' }
    ];

    //Menu fields definition
    public menuFields: FieldSettingsModel = {
        itemId: 'id',
        text: 'text',
        parentId: 'pId'
    };
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Custom menu items

The Angular Menu Bar can be customized using Essential® JS2 Template engine to render the elements.

To customize menu items in your application, set your customized template string to the template property.
In the following example, the menu has been rendered with customized menu items.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { MenuModule } from '@syncfusion/ej2-angular-navigations'
import { ButtonModule } from '@syncfusion/ej2-angular-buttons'



import { Component, Inject } from '@angular/core';
import { FieldSettingsModel } from '@syncfusion/ej2-angular-navigations';
import { enableRipple } from '@syncfusion/ej2-base';

enableRipple(false);

@Component({
imports: [ MenuModule, ButtonModule],

providers: [
    { provide: 'sourceFiles', useValue: {files: []}}],
    standalone: true,
    selector: 'app-root',
    styleUrls: ['./template.css'],
    template: `<div class="e-section-control">
    <div id="menuTemplate" class="menu-section">
    <div class="menu-control">
        <ejs-menu [items]='dataSource' [fields]='menuFields' [animationSettings]="animation" cssClass="e-template-menu">
            <ng-template #template let-dataSource="">
                
                <div *ngIf="dataSource.value" style="width:100%;display:flex;justify-content:space-between;">
                    <img *ngIf="dataSource.url" class="e-avatar e-avatar-small"
                        src="src/images/platforms/.png" />
                    <span style="width:100%;"></span>
                    <span *ngIf="dataSource.count" class='e-badge e-badge-success'></span>
                </div>
                <div *ngIf="dataSource.about" tabindex="0" class="e-card">
                    <div class="e-card-header">
                        <div class="e-card-header-caption">
                            <div class="e-card-header-title">About Us</div>
                        </div>
                    </div>
                    <div class="e-card-content">
                        
                    </div>
                    <div class="e-card-actions">
                        <button class="e-btn e-outline" style="pointer-events: auto;">
                            Read More
                        </button>
                    </div>
                </div>
            </ng-template>
        </ejs-menu>
    </div>
</div>
</div>`
})

export class AppComponent {
animation: any;
      constructor(@Inject('sourceFiles') public sourceFiles: any) {
        sourceFiles.files = ['template.css'];
    }
    //Template datasource
    public dataSource: { [key: string]: Object }[] = [
     {
            category: 'Products',
            options: [
                { value: 'JavaScript', url: 'https://ej2.syncfusion.com/angular/documentation/../../../../../menu/images/javascript' },
                { value: 'Angular', url: '../../../../../../menu/images/angular' },
                { value: 'ASP.NET Core', url: '../../../../../../menu/images/core' },
                { value: 'ASP.NET MVC', url: '../../../../../../menu/images/mvc' }
            ]
        },
        {
            category: 'Services',
            options: [
                { value: 'Application Development', count: '1200+' },
                { value: 'Maintenance & Support', count: '3700+' },
                { value: 'Quality Assurance' },
                { value: 'Cloud Integration', count: '900+' }
            ]
        },
        {
            category: 'About Us',
            options: [
                {
                    id: 'about',
                    about: {
                        value: "We are on a mission to provide world-class best software solutions for web, mobile and desktop platforms. Around 900+ applications are desgined and delivered to our customers to make digital & strengthen their businesses."
                    }
                }
            ]
        },
        { category: 'Careers' },
        { category: 'Sign In' }
    ];

    // Menu fields definition
    public menuFields: object = {
        text: ['category', 'value'],
        children: ['options']
    };
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

To prevent submenu closing, set args.cancel to true in the beforeClose event handler to enable custom interaction logic.

See Also

Data binding and custom menu items in React Menu

Data binding

The React Menu supports data source bindings such as an array of JavaScript objects that can be structured as either hierarchical or self-referential data.

Hierarchical data

The Menu can be populated with a hierarchical data source by assigning it to the items property, and the fields with corresponding keys can be mapped to the fields property.

JSON data

The React Menu can generate its menu items through an array of complex data by mapping fields from the fields property.

import { enableRipple } from '@syncfusion/ej2-base';
import { MenuComponent, } from '@syncfusion/ej2-react-navigations';
import * as React from 'react';
import * as ReactDom from 'react-dom';
enableRipple(true);
function App() {
    let dataSource = [
        {
            continent: 'Asia',
            countries: [
                {
                    country: 'China',
                    languages: [
                        { language: 'Chinese' },
                        { language: 'Cantonese' }
                    ]
                },
                {
                    country: 'India',
                    languages: [
                        { language: 'English' },
                        { language: 'Hindi' },
                        { language: 'Tamil' }
                    ]
                },
                {
                    country: 'Japan',
                    languages: [
                        { language: 'Japanese' }
                    ]
                }
            ]
        },
        {
            continent: 'Africa',
            countries: [
                {
                    country: 'Nigeria',
                    languages: [
                        { language: 'English' },
                        { language: 'Hausa' }
                    ]
                },
                {
                    country: 'Egypt',
                    languages: [
                        { language: 'Arabic' }
                    ]
                },
                {
                    country: 'South Africa',
                    languages: [
                        { language: 'Tswana' },
                        { language: 'Swati' }
                    ]
                }
            ]
        },
        {
            continent: 'North America',
            countries: [
                {
                    country: 'Canada',
                    languages: [
                        { language: 'French' }
                    ]
                },
                {
                    country: 'Mexico',
                    languages: [
                        { language: 'Spanish' }
                    ]
                },
                {
                    country: 'USA',
                    languages: [
                        { language: 'English' }
                    ]
                }
            ]
        },
        {
            continent: 'South America',
            countries: [
                {
                    country: 'Brazil',
                    languages: [
                        { language: 'Portuguese' }
                    ]
                },
                {
                    country: 'Colombia',
                    languages: [
                        { language: 'Spanish' }
                    ]
                },
                {
                    country: 'Argentina',
                    languages: [
                        { language: 'Spanish' }
                    ]
                }
            ]
        },
        {
            continent: 'Oceania',
            countries: [
                {
                    country: 'Australia'
                },
                {
                    country: 'New Zealand'
                },
                {
                    country: 'Samoa'
                },
            ]
        }
    ];
    // Menu fields definition
    let menuFields = {
        children: ['countries', 'languages'],
        text: ['continent', 'country', 'language']
    };
    return (<MenuComponent items={dataSource} fields={menuFields}/>);
}
export default App;
ReactDom.render(<App />, document.getElementById('element'));
import { enableRipple } from '@syncfusion/ej2-base';
import { FieldSettingsModel, MenuComponent,  } from '@syncfusion/ej2-react-navigations';
import * as React from 'react';
import * as ReactDom from 'react-dom';

enableRipple(true);

function App() {
    let dataSource: Array<{ [key: string]: any }> = [
        {
            continent: 'Asia',
            countries: [
                {
                    country: 'China',
                    languages: [
                        { language: 'Chinese' },
                        { language: 'Cantonese' }
                    ]
                },
                {
                    country: 'India',
                    languages: [
                        { language: 'English' },
                        { language: 'Hindi' },
                        { language: 'Tamil' }
                    ]
                },
                {
                    country: 'Japan',
                    languages: [
                        { language: 'Japanese' }
                    ]
                }
            ]
        },
        {
            continent: 'Africa',
            countries: [
                {
                    country: 'Nigeria',
                    languages: [
                        { language: 'English' },
                        { language: 'Hausa' }
                    ]
                },
                {
                    country: 'Egypt',
                    languages: [
                        { language: 'Arabic' }
                    ]
                },
                {
                    country: 'South Africa',
                    languages: [
                        { language: 'Tswana' },
                        { language: 'Swati' }
                    ]
                }
            ]
        },
        {
            continent: 'North America',
            countries: [
                {
                    country: 'Canada',
                    languages: [
                        { language: 'French' }
                    ]
                },
                {
                    country: 'Mexico',
                    languages: [
                        { language: 'Spanish' }
                    ]
                },
                {
                    country: 'USA',
                    languages: [
                        { language: 'English' }
                    ]
                }
            ]
        },
        {
            continent: 'South America',
            countries: [
                {
                    country: 'Brazil',
                    languages: [
                        { language: 'Portuguese' }
                    ]
                },
                {
                    country: 'Colombia',
                    languages: [
                        { language: 'Spanish' }
                    ]
                },
                {
                    country: 'Argentina',
                    languages: [
                        { language: 'Spanish' }
                    ]
                }
            ]
        },
        {
            continent: 'Oceania',
            countries: [
                {
                    country: 'Australia'
                },
                {
                    country: 'New Zealand'
                },
                {
                    country: 'Samoa'
                },
            ]
        }];

    // Menu fields definition
    let menuFields: FieldSettingsModel = {
        children: ['countries', 'languages'],
        text: ['continent', 'country', 'language']
    };

    return (
        <MenuComponent items={dataSource} fields={menuFields}/>
    );
}
export default App;
ReactDom.render(<App />,document.getElementById('element'));

Data Service

At the application level, remote data binding can be achieved using DataManager. To create the React Menu, assign the items property with the resultant data from the callback function.

The following example displays five employees’ FirstName from Employees table and ShipName details from Orders table of the Northwind Data Service.

import { enableRipple } from '@syncfusion/ej2-base';
import { DataManager, ODataV4Adaptor, Query } from '@syncfusion/ej2-data';
import { MenuComponent } from '@syncfusion/ej2-react-navigations';
import { useState, useEffect } from "react";
import * as React from 'react';
import * as ReactDom from 'react-dom';

const SERVICE_URI = 'https://services.odata.org/v4/Northwind/Northwind.svc/';

enableRipple(true);
function App() {
    const [menuItems, setState] = useState([]);
    // Menu fields definition.
    let menuFields = {
        children: ['Orders'],
        text: ['FirstName', 'ShipName']
    };

    useEffect(() => {
        new DataManager({ url: SERVICE_URI, adaptor: new ODataV4Adaptor(), crossDomain: true })
            .executeQuery(
                new Query().from('Employees').take(5).hierarchy(
                    new Query()
                        .foreignKey('EmployeeID')
                        .from('Orders').take(13),
                        select
            ))
            .then((e) => {
                setState(e.result);
        });
    }, []);

    function select() {
        return [1,2,3,4,5];
    }

    return (
        <div>
            {
                menuItems.length  ?
                <MenuComponent items={menuItems} fields={menuFields}/> : ''
            }
        </div>
    );
}
ReactDom.render(<App />, document.getElementById('element'));
import { enableRipple } from '@syncfusion/ej2-base';
import { DataManager, ODataV4Adaptor, Query, ReturnOption } from '@syncfusion/ej2-data';
import { FieldSettingsModel, MenuComponent } from '@syncfusion/ej2-react-navigations';
import { useState, useEffect } from "react";
import * as React from 'react';
import * as ReactDom from 'react-dom';

const SERVICE_URI: string = 'https://services.odata.org/v4/Northwind/Northwind.svc/';

enableRipple(true);

function App() {
    const [menuItems, setState] = useState([]);
    // Menu fields definition.
    let menuFields: FieldSettingsModel = {
        children: ['Orders'],
        text: ['FirstName', 'ShipName']
    };

    useEffect(() => {
        new DataManager({ url: SERVICE_URI, adaptor: new ODataV4Adaptor(), crossDomain: true })
            .executeQuery(
                new Query().from('Employees').take(5).hierarchy(
                    new Query()
                        .foreignKey('EmployeeID')
                        .from('Orders').take(13),
                        select
            ))
            .then((e: ReturnOption) => {
                setState(e.result as any);
        });
    }, []);

    function select(): number [] {
        return [1,2,3,4,5];
    }

    return (
        <div>
            {
                menuItems.length  ?
                <MenuComponent items={menuItems} fields={menuFields}/> : ''
            }
        </div>
    );
}

ReactDom.render(<App />,document.getElementById('element'));

Self-referential data

The React Menu can be populated from a self-referential data structure that contains an array of JSON objects with parentId mapping.

In the following example, the id, pId, and text columns from self-referential data have been mapped to the itemId, parentId, and text fields, respectively.

import { enableRipple } from '@syncfusion/ej2-base';
import { MenuComponent, } from '@syncfusion/ej2-react-navigations';
import * as React from 'react';
import * as ReactDom from 'react-dom';
enableRipple(true);
function App() {
    // Menu datasource
    let data = [
        { id: 'parent1', text: 'Events' },
        { id: 'parent2', text: 'Movies' },
        { id: 'parent3', text: 'Directory' },
        { id: 'parent4', pId: null, text: 'Queries' },
        { id: 'parent5', pId: null, text: 'Services' },
        { id: 'parent6', pId: 'parent1', text: 'Conferences' },
        { id: 'parent7', pId: 'parent1', text: 'Music' },
        { id: 'parent8', pId: 'parent1', text: 'Workshops' },
        { id: 'parent9', pId: 'parent2', text: 'Now Showing' },
        { id: 'parent10', pId: 'parent2', text: 'Coming Soon' },
        { id: 'parent10', pId: 'parent3', text: 'Media Gallery' },
        { id: 'parent11', pId: 'parent3', text: 'Newsletters' },
        { id: 'parent12', pId: 'parent4', text: 'Our Policy' },
        { id: 'parent13', pId: 'parent4', text: 'Site Map' },
        { id: 'parent14', pId: 'parent7', text: 'Pop' },
        { id: 'parent15', pId: 'parent7', text: 'Folk' },
        { id: 'parent16', pId: 'parent7', text: 'Classical' }
    ];
    // Menu fields definition
    let menuFields = {
        itemId: 'id',
        parentId: 'pId',
        text: 'text'
    };
    return (<MenuComponent items={data} fields={menuFields}/>);
}
export default App;
ReactDom.render(<App />, document.getElementById('element'));
import { enableRipple } from '@syncfusion/ej2-base';
import { FieldSettingsModel, MenuComponent,  } from '@syncfusion/ej2-react-navigations';
import * as React from 'react';
import * as ReactDom from 'react-dom';

enableRipple(true);

function App() {
    // Menu datasource
    let data: Array<{[key: string]: any }> = [
        { id: 'parent1', text: 'Events' },
        { id: 'parent2', text: 'Movies' },
        { id: 'parent3', text: 'Directory' },
        { id: 'parent4', pId: null, text: 'Queries' },
        { id: 'parent5', pId: null, text: 'Services' },
        { id: 'parent6', pId: 'parent1', text: 'Conferences' },
        { id: 'parent7', pId: 'parent1', text: 'Music' },
        { id: 'parent8', pId: 'parent1', text: 'Workshops' },
        { id: 'parent9', pId: 'parent2', text: 'Now Showing' },
        { id: 'parent10', pId: 'parent2', text: 'Coming Soon' },
        { id: 'parent10', pId: 'parent3', text: 'Media Gallery' },
        { id: 'parent11', pId: 'parent3', text: 'Newsletters' },
        { id: 'parent12', pId: 'parent4', text: 'Our Policy' },
        { id: 'parent13', pId: 'parent4', text: 'Site Map' },
        { id: 'parent14', pId: 'parent7', text: 'Pop' },
        { id: 'parent15', pId: 'parent7', text: 'Folk' },
        { id: 'parent16', pId: 'parent7', text: 'Classical' }
    ];

    // Menu fields definition
    let menuFields: FieldSettingsModel = {
        itemId:'id',
        parentId: 'pId',
        text: 'text'
    };

    return (
        <MenuComponent items={data} fields={menuFields}/>
    );
}
export default App;
ReactDom.render(<App />,document.getElementById('element'));

Custom menu items

The React Menu can be customized using the Syncfusion® Essential JS 2 template property to render the elements.

To customize React menu items in your application, set your customized template string to the template property. In the following example, the React menu has been rendered with customized menu items.

import { enableRipple } from '@syncfusion/ej2-base';
import { MenuComponent } from '@syncfusion/ej2-react-navigations';
import * as React from 'react';
import * as ReactDom from 'react-dom';
enableRipple(false);
function App() {
    // Menu fields definition
    let menuFields = {
        children: ['options'],
        text: ['category', 'value']
    };
    // Menu data definition
    let data = [
        {
            category: 'Products',
            options: [
                { value: 'JavaScript', url: 'javascript' },
                { value: 'Angular', url: 'angular' },
                { value: 'ASP.NET Core', url: 'core' },
                { value: 'ASP.NET MVC', url: 'mvc' }
            ]
        },
        {
            category: 'Services',
            options: [
                {
                    support: [
                        { id: 1, count: '1200+', value: 'Application Development' },
                        { id: 2, count: '3700+', value: 'Maintenance & Support' },
                        { id: 3, value: 'Quality Assurance' },
                        { id: 4, count: '900+', value: 'Cloud Integration' }
                    ]
                }
            ]
        },
        {
            category: 'About Us',
            options: [
                {
                    about: {
                        value: "We are on a mission to provide world-class best software solutions for web, mobile and desktop platforms. Around 900+ applications are desgined and delivered to our customers to make digital & strengthen their businesses."
                    }
                }
            ]
        },
        { category: 'Careers' },
        { category: 'Sign In' }
    ];
    function menuTemplate(data) {
        return (data.category ? <span>{data.category}</span> :
            (data.value && data.url) ?
                <div className='e-avatar e-avatar-small image' style={{ backgroundImage: 'url(https://ej2.syncfusion.com/react/demos/src/menu/images/' + data.url + '.png)' }}>{data.value}</div> :
                data.support ?
                    <ul>
                            {data.support.map((supp) => <li key={supp.id}>
                                    {supp.value}
                                    {supp.count ? <span className='e-badge e-badge-success'>{supp.count}</span> : ""}
                                </li>)}
                        </ul> :
                    <div tabIndex={0} className="e-card">
                            <div className="e-card-header">
                                <div className="e-card-header-caption">
                                    <div className="e-card-header-title">About Us</div>
                                </div>
                            </div>
                            <div className="e-card-content">
                                {data.about.value}
                            </div>
                            <div className="e-card-actions">
                                <button className="e-btn e-outline">
                                    Read More
                    </button>
                            </div>
                        </div>);
    }
    return (<div className="menu-section">
            <MenuComponent items={data} fields={menuFields} template={menuTemplate}/>
        </div>);
}
export default App;
ReactDom.render(<App />, document.getElementById('element'));
import { enableRipple } from '@syncfusion/ej2-base';
import { FieldSettingsModel, MenuComponent } from '@syncfusion/ej2-react-navigations';
import * as React from 'react';
import * as ReactDom from 'react-dom';

enableRipple(false);

function App() {
    // Menu fields definition
    let menuFields: FieldSettingsModel  = {
        children: ['options'],
        text: ['category', 'value']
    };
    // Menu data definition
    let data: Array<{ [key: string]: any }> = [
        {
            category: 'Products',
            options: [
                { value: 'JavaScript', url: 'javascript' },
                { value: 'Angular', url: 'angular' },
                { value: 'ASP.NET Core', url: 'core' },
                { value: 'ASP.NET MVC', url: 'mvc' }
            ]
        },
        {
            category: 'Services',
            options: [
                {
                    support: [
                        { id: 1, count: '1200+', value: 'Application Development' },
                        { id: 2, count: '3700+', value: 'Maintenance & Support' },
                        { id: 3, value: 'Quality Assurance' },
                        { id: 4, count: '900+', value: 'Cloud Integration' }
                    ]
                }
            ]
        },
        {
            category: 'About Us',
            options: [
                {
                    about: {
                        value: "We are on a mission to provide world-class best software solutions for web, mobile and desktop platforms. Around 900+ applications are desgined and delivered to our customers to make digital & strengthen their businesses."
                    }
                }
            ]
        },
        { category: 'Careers' },
        { category: 'Sign In' }
    ];

    function menuTemplate(data: any): JSX.Element {
        return (
            data.category ? <span>{data.category}</span> :
                (data.value && data.url) ?
                    <div className='e-avatar e-avatar-small image' style={{ backgroundImage: 'url(https://ej2.syncfusion.com/react/demos/src/menu/images/' + data.url + '.png)' }}>{data.value}</div> :
                    data.support ?
                        <ul>
                            {
                                data.support.map((supp: any) => <li key={supp.id}>
                                    {supp.value}
                                    {
                                        supp.count ? <span className='e-badge e-badge-success'>{supp.count}</span> : ""
                                    }
                                </li>)
                            }
                        </ul> :
                        <div tabIndex={0} className="e-card">
                            <div className="e-card-header">
                                <div className="e-card-header-caption">
                                    <div className="e-card-header-title">About Us</div>
                                </div>
                            </div>
                            <div className="e-card-content">
                                {data.about.value}
                            </div>
                            <div className="e-card-actions">
                                <button className="e-btn e-outline">
                                    Read More
                    </button>
                            </div>
                        </div>
        );
    }

    return (
        <div className="menu-section">
            <MenuComponent items={data} fields={menuFields} template={menuTemplate}/>
        </div>
    );
}
export default App;
ReactDom.render(<App />,document.getElementById('element'));

To prevent a submenu from closing, set args.cancel to true in the beforeClose event.

See Also

Data Source Binding and Custom Menu Items in Vue Menu Bar

20 Aug 202624 minutes to read

Data binding

The Menu supports data source bindings such as array of JavaScript objects that can be structured as either hierarchical or self-referential data.

Hierarchical data

The Menu can be populated with hierarchical data source by assigning it to the items property, and the fields with corresponding keys can be mapped to the fields property.

JSON data

The Menu can generate its menu items through an array of complex data source by mapping fields from the fields property.

<template>
    <div>
        <ejs-menu :items='datasource' :fields='menuFields'></ejs-menu>
    </div>
</template>

<script setup>

import { MenuComponent as EjsMenu } from "@syncfusion/ej2-vue-navigations";
import { enableRipple } from '@syncfusion/ej2-base';

enableRipple(true);

//Menu datasource
const datasource = [
    {
        continent: 'Asia',
        countries: [
            {
                country: 'China',
                languages: [
                    { language: 'Chinese' },
                    { language: 'Cantonese' }
                ]
            },
            {
                country: 'India',
                languages: [
                    { language: 'English' },
                    { language: 'Hindi' },
                    { language: 'Tamil' }
                ]
            },
            {
                country: 'Japan',
                languages: [
                    { language: 'Japanese' }
                ]
            }
        ]
    },
    {
        continent: 'Africa',
        countries: [
            {
                country: 'Nigeria',
                languages: [
                    { language: 'English' },
                    { language: 'Hausa' }
                ]
            },
            {
                country: 'Egypt',
                languages: [
                    { language: 'Arabic' }
                ]
            },
            {
                country: 'South Africa',
                languages: [
                    { language: 'Tswana' },
                    { language: 'Swati' }
                ]
            }
        ]
    },
    {
        continent: 'North America',
        countries: [
            {
                country: 'Canada',
                languages: [
                    { language: 'French' }
                ]
            },
            {
                country: 'Mexico',
                languages: [
                    { language: 'Spanish' }
                ]
            },
            {
                country: 'USA',
                languages: [
                    { language: 'English' }
                ]
            }
        ]
    },
    {
        continent: 'South America',
        countries: [
            {
                country: 'Brazil',
                languages: [
                    { language: 'Portuguese' }
                ]
            },
            {
                country: 'Colombia',
                languages: [
                    { language: 'Spanish' }
                ]
            },
            {
                country: 'Argentina',
                languages: [
                    { language: 'Spanish' }
                ]
            }
        ]
    },
    {
        continent: 'Oceania',
        countries: [
            {
                country: 'Australia'
            },
            {
                country: 'New Zealand'
            },
            {
                country: 'Samoa'
            },
        ]
    }
];
const menuFields = {
    text: ['continent', 'country', 'language'],
    children: ['countries', 'languages']
};

</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/material.css";

body {
    margin-top: 100px;
    text-align: center;
}
</style>
<template>
    <div>
        <ejs-menu :items='datasource' :fields='menuFields'></ejs-menu>
    </div>
</template>

<script>

import { MenuComponent } from "@syncfusion/ej2-vue-navigations";
import { enableRipple } from '@syncfusion/ej2-base';

enableRipple(true);

export default {
    name: "App",
    components: {
        "ejs-menu": MenuComponent
    },
    data: function () {
        return {
            //Menu datasource
            datasource: [
                {
                    continent: 'Asia',
                    countries: [
                        {
                            country: 'China',
                            languages: [
                                { language: 'Chinese' },
                                { language: 'Cantonese' }
                            ]
                        },
                        {
                            country: 'India',
                            languages: [
                                { language: 'English' },
                                { language: 'Hindi' },
                                { language: 'Tamil' }
                            ]
                        },
                        {
                            country: 'Japan',
                            languages: [
                                { language: 'Japanese' }
                            ]
                        }
                    ]
                },
                {
                    continent: 'Africa',
                    countries: [
                        {
                            country: 'Nigeria',
                            languages: [
                                { language: 'English' },
                                { language: 'Hausa' }
                            ]
                        },
                        {
                            country: 'Egypt',
                            languages: [
                                { language: 'Arabic' }
                            ]
                        },
                        {
                            country: 'South Africa',
                            languages: [
                                { language: 'Tswana' },
                                { language: 'Swati' }
                            ]
                        }
                    ]
                },
                {
                    continent: 'North America',
                    countries: [
                        {
                            country: 'Canada',
                            languages: [
                                { language: 'French' }
                            ]
                        },
                        {
                            country: 'Mexico',
                            languages: [
                                { language: 'Spanish' }
                            ]
                        },
                        {
                            country: 'USA',
                            languages: [
                                { language: 'English' }
                            ]
                        }
                    ]
                },
                {
                    continent: 'South America',
                    countries: [
                        {
                            country: 'Brazil',
                            languages: [
                                { language: 'Portuguese' }
                            ]
                        },
                        {
                            country: 'Colombia',
                            languages: [
                                { language: 'Spanish' }
                            ]
                        },
                        {
                            country: 'Argentina',
                            languages: [
                                { language: 'Spanish' }
                            ]
                        }
                    ]
                },
                {
                    continent: 'Oceania',
                    countries: [
                        {
                            country: 'Australia'
                        },
                        {
                            country: 'New Zealand'
                        },
                        {
                            country: 'Samoa'
                        },
                    ]
                }
            ],
            menuFields: {
                text: ['continent', 'country', 'language'],
                children: ['countries', 'languages']
            }
        };
    }
}
</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/material.css";

body {
    margin-top: 100px;
    text-align: center;
}
</style>

Data Service

In application level, remote data binding can be achieved using DataManager.

To create Menu, assign items property with resultant data from callback function.

<template>
  <div class="template-menu-control">
    <ejs-menu v-if="items" :items="items" :fields="menuFields"></ejs-menu>
  </div>
</template>

<script setup>
import { ref } from "vue";
import { MenuComponent as EjsMenu } from "@syncfusion/ej2-vue-navigations";
import { ODataV4Adaptor, DataManager, Query } from "@syncfusion/ej2-data";
import { enableRipple } from '@syncfusion/ej2-base';

enableRipple(true);

const items = ref(null);
const SERVICE_URI = 'https://services.odata.org/V4/Northwind/Northwind.svc/';


const menuFields = {
  text: ['FirstName', 'ShipName'],
  children: ['Orders']
};

const menuItems = function () {
  new DataManager({ url: SERVICE_URI, adaptor: new ODataV4Adaptor(), crossDomain: true })
    .executeQuery(
      new Query().from('Employees').take(5).hierarchy(
        new Query()
          .foreignKey('EmployeeID')
          .from('Orders').take(13),
        function () {
          return [1, 2, 3, 4, 5]
        }
      ))
    .then((e) => {
      items.value = e.result
    });
  return items.value;
}

items.value = menuItems();

</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/material.css";

.template-menu-control {
  margin-top: 100px;
  text-align: center;
}
</style>
<template>
    <div class="template-menu-control">
        <ejs-menu v-if="items" :items="items" :fields="menuFields"></ejs-menu>
    </div>
</template>

<script>

import { MenuComponent } from "@syncfusion/ej2-vue-navigations";
import { ODataV4Adaptor, DataManager, Query } from "@syncfusion/ej2-data";
import { enableRipple } from '@syncfusion/ej2-base';

enableRipple(true);

var SERVICE_URI = 'https://services.odata.org/V4/Northwind/Northwind.svc/';

export default {
    name: "App",
    components: {
        "ejs-menu": MenuComponent
    },
    data: function () {
        return {
            items: this.menuItems(),
            menuFields: {
                text: ['FirstName', 'ShipName'],
                children: ['Orders']
            }
        }
    },
    methods: {
        menuItems() {
            new DataManager({ url: SERVICE_URI, adaptor: new ODataV4Adaptor(), crossDomain: true })
                .executeQuery(
                    new Query().from('Employees').take(5).hierarchy(
                        new Query()
                            .foreignKey('EmployeeID')
                            .from('Orders').take(13),
                        function () {
                            return [1, 2, 3, 4, 5]
                        }
                    ))
                .then((e) => {
                    this.items = e.result
                });
            return this.items;
        }
    }
}
</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/material.css";

.template-menu-control {
    margin-top: 100px;
    text-align: center;
}
</style>

Self-referential data

Menu can be populated from self-referential data structure that contains array of JSON objects with parentId mapping.

In the following example, the id, pId, and text columns from self-referential data have been mapped to the itemId, parentId, and text fields, respectively.

<template>
    <div>
        <ejs-menu :items='datasource' :fields='menuFields'></ejs-menu>
    </div>
</template>

<script setup>

import { MenuComponent as EjsMenu } from "@syncfusion/ej2-vue-navigations";
import { enableRipple } from '@syncfusion/ej2-base';

enableRipple(true);

//Menu datasource
const datasource = [
    { id: 'parent1', text: 'Events' },
    { id: 'parent2', text: 'Movies' },
    { id: 'parent3', text: 'Directory' },
    { id: 'parent4', text: 'Queries', pId: null },
    { id: 'parent5', text: 'Services', pId: null },

    { id: 'parent6', text: 'Conferences', pId: 'parent1' },
    { id: 'parent7', text: 'Music', pId: 'parent1' },
    { id: 'parent8', text: 'Workshops', pId: 'parent1' },

    { id: 'parent9', text: 'Now Showing', pId: 'parent2' },
    { id: 'parent10', text: 'Coming Soon', pId: 'parent2' },

    { id: 'parent10', text: 'Media Gallery', pId: 'parent3' },
    { id: 'parent11', text: 'Newsletters', pId: 'parent3' },

    { id: 'parent12', text: 'Our Policy', pId: 'parent4' },
    { id: 'parent13', text: 'Site Map', pId: 'parent4' },
    { id: 'parent14', text: 'Pop', pId: 'parent7' },
    { id: 'parent15', text: 'Folk', pId: 'parent7' },
    { id: 'parent16', text: 'Classical', pId: 'parent7' }
];

//Menu fields definition
const menuFields = {
    itemId: 'id',
    text: 'text',
    parentId: 'pId'
}

</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/material.css";

body {
    margin-top: 100px;
    text-align: center;
}
</style>
<template>
    <div>
        <ejs-menu :items='datasource' :fields='menuFields'></ejs-menu>
    </div>
</template>

<script>

import { MenuComponent } from "@syncfusion/ej2-vue-navigations";
import { enableRipple } from '@syncfusion/ej2-base';

enableRipple(true);


export default {
    name: "App",
    components: {
        "ejs-menu": MenuComponent
    },
    data: function () {
        return {
            //Menu datasource
            datasource: [
                { id: 'parent1', text: 'Events' },
                { id: 'parent2', text: 'Movies' },
                { id: 'parent3', text: 'Directory' },
                { id: 'parent4', text: 'Queries', pId: null },
                { id: 'parent5', text: 'Services', pId: null },

                { id: 'parent6', text: 'Conferences', pId: 'parent1' },
                { id: 'parent7', text: 'Music', pId: 'parent1' },
                { id: 'parent8', text: 'Workshops', pId: 'parent1' },

                { id: 'parent9', text: 'Now Showing', pId: 'parent2' },
                { id: 'parent10', text: 'Coming Soon', pId: 'parent2' },

                { id: 'parent10', text: 'Media Gallery', pId: 'parent3' },
                { id: 'parent11', text: 'Newsletters', pId: 'parent3' },

                { id: 'parent12', text: 'Our Policy', pId: 'parent4' },
                { id: 'parent13', text: 'Site Map', pId: 'parent4' },
                { id: 'parent14', text: 'Pop', pId: 'parent7' },
                { id: 'parent15', text: 'Folk', pId: 'parent7' },
                { id: 'parent16', text: 'Classical', pId: 'parent7' }
            ],
            //Menu fields definition
            menuFields: {
                itemId: 'id',
                text: 'text',
                parentId: 'pId'
            }
        };

    }
}
</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/material.css";

body {
    margin-top: 100px;
    text-align: center;
}
</style>

Custom menu items

The Menu can be customized using Essential® JS2 Template engine to render the elements.

To customize menu items in your application, set your customized template string to the template property. In the following example, the menu has been rendered with customized menu items.

Install Syncfusion® Layouts and Navigations packages using below command.

npm install @syncfusion/ej2-vue-layouts --save
npm install @syncfusion/ej2-vue-navigations --save
<template>
    <div class="template-menu-control">
        <ejs-menu :items="data" :fields="menuFields" :template="menuTemplate"></ejs-menu>
    </div>
</template>

<script setup>

import { MenuComponent as EjsMenu } from "@syncfusion/ej2-vue-navigations";
import { createApp } from "vue";

var menutemplateVue = createApp().component("demo", {
    template: '  <span v-if="data.category">  </span>' +
        ' <div v-else-if="data.value" style="width: 100%;display: flex;justify-content: space-between;">' +
        '<img v-if="data.url" class="e-avatar e-avatar-small" v-bind:style="image" />' +
        '<span style="width:100%;"></span></div>' +
        '<span class="e-menu-template" v-else-if="data.support">' +
        '<ul>' +
        '<li v-bind:key="index" v-for="(val,index) of data.support">' +
        '  ' +
        '<span v-if="val.count" class="e-badge e-badge-success"></span> ' +
        ' </li> ' +
        '</ul>' +
        '</span>' +
        '<div tabindex="0" class="e-card" v-else>' +
        '<div class="e-card-header">' +
        '<div class="e-card-header-caption">' +
        '<div class="e-card-header-title">About Us</div>' +
        '</div>' +
        '</div>' +
        '<div class="e-card-content"> </div>' +
        '<div class="e-card-actions">' +
        '<button class="e-btn e-outline">Read More </button>' +
        '</div>' +
        '</div>',
    data() {
        return {
            data: {}
        }
    },
    computed: {
        image: function () {
            return 'background-image: url(https://ej2.syncfusion.com/react/demos/src/menu/images/' + this.data.url + '.png);';
        }
    }
});

const data = [
    {
        category: 'Products',
        options: [
            { value: 'JavaScript', url: 'javascript' },
            { value: 'Angular', url: 'angular' },
            { value: 'ASP.NET Core', url: 'core' },
            { value: 'ASP.NET MVC', url: 'mvc' }
        ]
    },
    {
        category: 'Services',
        options: [
            {
                support: [
                    { value: 'Application Development', count: '1200+' },
                    { value: 'Maintenance & Support', count: '3700+' },
                    { value: 'Quality Assurance' },
                    { value: 'Cloud Integration', count: '900+' }
                ]
            }
        ]
    },
    {
        category: 'About Us',
        options: [
            {
                about: {
                    value: "We are on a mission to provide world-class best software solutions for web, mobile and desktop platforms. Around 900+ applications are desgined and delivered to our customers to make digital & strengthen their businesses."
                }
            }
        ]
    },
    { category: 'Careers' },
    { category: 'Sign In' }
];
const menuFields = {
    text: ['category', 'value'],
    children: ['options']
};
const menuTemplate = () => {
    return {
        template: menutemplateVue
    }
};

</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-inputs/styles/material.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-notifications/styles/material.css";
@import "../node_modules/@syncfusion/ej2-layouts/styles/material.css";
/* ej2 Menu template styles */

.template-menu-control {
    margin-top: 45px;
    text-align: center;
}

/* Common customization */

.e-bigger .template-menu-control .e-menu-wrapper.e-control ul.e-ul .e-menu-item,
.template-menu-control .e-menu-wrapper.e-control ul.e-ul .e-menu-item,
.template-menu-control .e-menu-wrapper.e-control ul.e-ul .e-menu-item .e-menu-template {
    display: flex;
    height: auto;
    padding: 0;
}

/* Avatar customization */

.e-bigger .template-menu-control .e-menu-wrapper ul .e-menu-item .e-avatar {
    background-size: auto;
    text-indent: 40px;
}

.template-menu-control .e-menu-wrapper ul .e-menu-item .e-avatar {
    background-color: inherit;
    background-position: 0;
    background-size: 25px;
    color: inherit;
    font-size: inherit;
    height: inherit;
    justify-content: left;
    margin: 0 10px;
    width: 100%;
    text-indent: 35px;
}

/* Badge customization */

.template-menu-control .e-menu-wrapper ul .e-menu-item ul li {
    padding: 0 10px;
}

.e-bigger .template-menu-control .e-menu-wrapper ul .e-menu-item ul li .e-badge {
    margin: 18px 0px 0px 10px;
}

.template-menu-control .e-menu-wrapper ul .e-menu-item ul li .e-badge {
    float: right;
    margin: 13px 0px 0px 10px;
}

.template-menu-control .e-menu-wrapper ul .e-menu-item ul li:hover {
    background-color: #eee;
}

/* Card customization */

.e-bigger .template-menu-control .e-menu-wrapper ul.e-ul .e-menu-item .e-card {
    width: 320px;
}

.template-menu-control .e-menu-wrapper ul.e-ul .e-menu-item .e-card {
    width: 290px;
    font-size: inherit;
    cursor: default;
    background-color: inherit;
    border-color: transparent;
}

.template-menu-control .e-menu-wrapper ul.e-ul .e-menu-item .e-card .e-card-content {
    white-space: normal;
    color: inherit;
    padding-top: 0;
    text-align: justify;
    font-size: inherit;
}

.e-bigger .template-menu-control .e-menu-wrapper ul.e-ul .e-menu-item .e-card .cb-icons {
    width: 40px;
    font-size: 40px;
    height: 40px;
}

.template-menu-control .e-menu-wrapper ul.e-ul .e-menu-item .e-card .cb-icons {
    width: 30px;
    font-size: 30px;
    height: 30px;
}

.template-menu-control .e-menu-wrapper ul.e-ul .e-menu-item .e-card .e-card-btn {
    background-color: inherit;
}
</style>
<template>
    <div class="template-menu-control">
        <ejs-menu :items="data" :fields="menuFields" :template="menuTemplate"></ejs-menu>
    </div>
</template>

<script>

import { MenuComponent } from "@syncfusion/ej2-vue-navigations";
import { createApp } from "vue";

export default {
    name: "App",
    components: {
        "ejs-menu": MenuComponent
    },
    data: function () {
        var menutemplateVue = createApp().component("demoTemplate", {
            template: '  <span v-if="data.category">  </span>' +
                ' <div v-else-if="data.value" style="width: 100%;display: flex;justify-content: space-between;">' +
                '<img v-if="data.url" class="e-avatar e-avatar-small" v-bind:style="image" />' +
                '<span style="width:100%;"></span></div>' +
                '<span class="e-menu-template" v-else-if="data.support">' +
                '<ul>' +
                '<li v-bind:key="index" v-for="(val,index) of data.support">' +
                '  ' +
                '<span v-if="val.count" class="e-badge e-badge-success"></span> ' +
                ' </li> ' +
                '</ul>' +
                '</span>' +
                '<div tabindex="0" class="e-card" v-else>' +
                '<div class="e-card-header">' +
                '<div class="e-card-header-caption">' +
                '<div class="e-card-header-title">About Us</div>' +
                '</div>' +
                '</div>' +
                '<div class="e-card-content"> </div>' +
                '<div class="e-card-actions">' +
                '<button class="e-btn e-outline">Read More </button>' +
                '</div>' +
                '</div>',
            data() {
                return {
                    data: {}
                }
            },
            computed: {
                image: function () {
                    return 'background-image: url(https://ej2.syncfusion.com/react/demos/src/menu/images/' + this.data.url + '.png);';
                }
            }
        });

        return {
            data: [
                {
                    category: 'Products',
                    options: [
                        { value: 'JavaScript', url: 'javascript' },
                        { value: 'Angular', url: 'angular' },
                        { value: 'ASP.NET Core', url: 'core' },
                        { value: 'ASP.NET MVC', url: 'mvc' }
                    ]
                },
                {
                    category: 'Services',
                    options: [
                        {
                            support: [
                                { value: 'Application Development', count: '1200+' },
                                { value: 'Maintenance & Support', count: '3700+' },
                                { value: 'Quality Assurance' },
                                { value: 'Cloud Integration', count: '900+' }
                            ]
                        }
                    ]
                },
                {
                    category: 'About Us',
                    options: [
                        {
                            about: {
                                value: "We are on a mission to provide world-class best software solutions for web, mobile and desktop platforms. Around 900+ applications are desgined and delivered to our customers to make digital & strengthen their businesses."
                            }
                        }
                    ]
                },
                { category: 'Careers' },
                { category: 'Sign In' }
            ],
            menuFields: {
                text: ['category', 'value'],
                children: ['options']
            },
            menuTemplate: function () {
                return {
                    template: menutemplateVue
                }
            }
        };
    }
}
</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-inputs/styles/material.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-notifications/styles/material.css";
@import "../node_modules/@syncfusion/ej2-layouts/styles/material.css";
/* ej2 Menu template styles */

.template-menu-control {
    margin-top: 45px;
    text-align: center;
}

/* Common customization */

.e-bigger .template-menu-control .e-menu-wrapper.e-control ul.e-ul .e-menu-item,
.template-menu-control .e-menu-wrapper.e-control ul.e-ul .e-menu-item,
.template-menu-control .e-menu-wrapper.e-control ul.e-ul .e-menu-item .e-menu-template {
    display: flex;
    height: auto;
    padding: 0;
}

/* Avatar customization */

.e-bigger .template-menu-control .e-menu-wrapper ul .e-menu-item .e-avatar {
    background-size: auto;
    text-indent: 40px;
}

.template-menu-control .e-menu-wrapper ul .e-menu-item .e-avatar {
    background-color: inherit;
    background-position: 0;
    background-size: 25px;
    color: inherit;
    font-size: inherit;
    height: inherit;
    justify-content: left;
    margin: 0 10px;
    width: 100%;
    text-indent: 35px;
}

/* Badge customization */

.template-menu-control .e-menu-wrapper ul .e-menu-item ul li {
    padding: 0 10px;
}

.e-bigger .template-menu-control .e-menu-wrapper ul .e-menu-item ul li .e-badge {
    margin: 18px 0px 0px 10px;
}

.template-menu-control .e-menu-wrapper ul .e-menu-item ul li .e-badge {
    float: right;
    margin: 13px 0px 0px 10px;
}

.template-menu-control .e-menu-wrapper ul .e-menu-item ul li:hover {
    background-color: #eee;
}

/* Card customization */

.e-bigger .template-menu-control .e-menu-wrapper ul.e-ul .e-menu-item .e-card {
    width: 320px;
}

.template-menu-control .e-menu-wrapper ul.e-ul .e-menu-item .e-card {
    width: 290px;
    font-size: inherit;
    cursor: default;
    background-color: inherit;
    border-color: transparent;
}

.template-menu-control .e-menu-wrapper ul.e-ul .e-menu-item .e-card .e-card-content {
    white-space: normal;
    color: inherit;
    padding-top: 0;
    text-align: justify;
    font-size: inherit;
}

.e-bigger .template-menu-control .e-menu-wrapper ul.e-ul .e-menu-item .e-card .cb-icons {
    width: 40px;
    font-size: 40px;
    height: 40px;
}

.template-menu-control .e-menu-wrapper ul.e-ul .e-menu-item .e-card .cb-icons {
    width: 30px;
    font-size: 30px;
    height: 30px;
}

.template-menu-control .e-menu-wrapper ul.e-ul .e-menu-item .e-card .e-card-btn {
    background-color: inherit;
}
</style>

See Also